summaryrefslogtreecommitdiff
path: root/tests/ls/stat-dtype
diff options
context:
space:
mode:
Diffstat (limited to 'tests/ls/stat-dtype')
-rwxr-xr-xtests/ls/stat-dtype51
1 files changed, 51 insertions, 0 deletions
diff --git a/tests/ls/stat-dtype b/tests/ls/stat-dtype
new file mode 100755
index 000000000..30a84b655
--- /dev/null
+++ b/tests/ls/stat-dtype
@@ -0,0 +1,51 @@
+#!/bin/sh
+# Ensure that ls --file-type does not call stat unnecessarily.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ ls --version
+fi
+
+. $srcdir/../envvar-check
+
+# Skip this test unless "." is on a file system with useful d_type info.
+# FIXME: use a more dynamic test for this, since whether
+# d_type is useful depends on much more than the file system type.
+# For example, with linux-2.6.15, at least tmpfs, ext3 and reiserfs work,
+# but xfs doesn't. Here's hoping that this kludge is enough for now.
+df -t tmpfs -t ext3 -t reiserfs . 2> /dev/null ||
+ {
+ echo "$0: '.' is not on a suitable file system for this test" 1>&2
+ echo "$0: skipping this test" 1>&2
+ (exit 77); exit 77
+ }
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+mkdir d || framework_failure=1
+ln -s / d/s || framework_failure=1
+chmod 600 d || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+ls --file-type d > out || fail=1
+cat <<\EOF > exp || fail=1
+s@
+EOF
+
+cmp out exp || fail=1
+test $fail = 1 && diff out exp 2> /dev/null
+
+(exit $fail); exit $fail